--
-- Union of Pages and Tracks
--
SELECT
    e.id,
    e.timestamp,
    event_type,
    event_name,
    page_type,
    received_at,
    sent_at,
    uuid,
    e.anonymous_id,
    --
    e.anonymous_id as original_anonymous_id,
    e.user_id,
    e.context_page_url,
    e.context_ip,
    e.context_campaign_medium,
    e.context_campaign_source,
    e.context_campaign_name,
    e.context_campaign_content,
    e.context_campaign_term,
    e.context_campaign_image_campaign,
    e.context_page_title,
    e.context_page_search,
    e.event_text,
    e.context_library_name,
    e.context_library_version,
    e.context_page_path,
    e.context_page_referrer,
    e.context_user_agent,
    e.context_amp_id,
    e.is_amp
FROM (
    SELECT
        t.id,
        t."timestamp",
        'track'           AS event_type,
        t.event           AS event_name,
        NULL::varchar AS page_type,
        t.received_at,
        t.sent_at,
        t.uuid,
        --
        t.anonymous_id,
        -- t.anonymous_id as original_anonymous_id,
        t.user_id,
        t.context_page_url,
        t.context_ip,
        t.context_campaign_medium,
        t.context_campaign_source,
        t.context_campaign_name,
        t.context_campaign_content,
        t.context_campaign_term,
        t.context_campaign_image_campaign,
        t.context_page_title,
        t.context_page_search,
        t.event_text,
        t.context_library_name,
        t.context_library_version,
        t.context_page_path,
        t.context_page_referrer,
        t.context_user_agent,
        t.context_amp_id,
        t.context_library_name='amp' as is_amp
    FROM consumer_web.tracks t
    WHERE t.timestamp < t.sent_at + INTERVAL '1 HOUR'
    UNION
    SELECT
        p.id,
        p."timestamp",
        'page'            AS event_type,
        p.name            AS event_name,
        p.page_type,
        p.received_at,
        p.sent_at,
        p.uuid,
        p.anonymous_id,
        -- p.anonymous_id as original_anonymous_id,
        p.user_id,
        p.context_page_url,
        p.context_ip,
        p.context_campaign_medium,
        p.context_campaign_source,
        p.context_campaign_name,
        p.context_campaign_content,
        p.context_campaign_term,
        p.context_campaign_image_campaign,
        p.context_page_title,
        p.context_page_search,
        NULL :: "unknown" AS event_text,
        p.context_library_name,
        p.context_library_version,
        p.context_page_path,
        p.context_page_referrer,
        p.context_user_agent,
        p.context_amp_id,
        p.context_library_name = 'amp' as is_amp
    FROM consumer_web.pages p
    WHERE p.timestamp < p.sent_at + INTERVAL '1 HOUR'
) e

